/*
    Copyright (c) 2015 digitalSTROM AG, Zurich, Switzerland

    Authors: Christian Hitz, digitalSTROM AG <christian.hitz@digitalstrom.com>
             Michael Tross, digitalSTROM AG <michael.tross@digitalstrom.com>
             Reto Flütsch, digitalSTROM AG <reto.fluetsch@digitalstrom.com>

    This file is part of vdSM.

    vdSM is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 2 of the License.
    

    vdSM is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with vdSM. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef GROUP_H_
#define GROUP_H_

#include "qp_port.h"
#include "types.h"

typedef struct GroupTag {
    QHsm super;
    QActive * parent;
    struct SharedOpTimeEvtTag *opTimer1;
    struct SharedOpTimeEvtTag *opTimer2;
    struct StopTimerEvtTag *stopTimer;
    uint8_t localZoneId;
    uint8_t groupId;
    uint8_t buttonId;
    uint8_t key;
    uint16_t fid;
    uint16_t deviceId;
    bool setLocalPriority;
    uint8_t outputChannel;
    bool callMinDim;
    uint8_t padding;
} Group;

void Group_ctor(Group *me);

#define Group_init(me_)             QHsm_init((QHsm *)(me_), (QEvent *)0)
#define Group_dispatch(me_, e_)     QHsm_dispatch((QHsm *)(me_), e_)

bool Group_is_off_state(const QStateHandler state);

#endif /* GROUP_H_ */
